<template>
    <div :class='calendarClass'>
      <context-menu-container>
        <template>
        <div class="event-legends">
          <div :class="{'event-lengend':true, 'item':true, 'event-disabled':!isShowlegend.item}" @click="legendTrigger('item')">
            <div class="lengend-icon" style="background:rgba(0, 21, 255, 1);"></div>
            <span style="color:rgba(30, 255, 0, 1);">图书</span>
          </div>
        </div>
        <FullCalendar
          ref="calendar"
          :locale="$i18n.locale"
          height="parent"
          :firstDay="1"
          :eventLimit="true"
          :editable="!isSelectFirstDefault && true"
          :buttonText="buttonText" 
          :header="header"
          :plugins="calendarPlugins"
          :events="searchEvents"
          :displayEventTime="displayEventTime"
          :customButtons="customButtons"
          :validRange="validRange"
          :defaultDate="defaultDate"
          :eventRender="eventRender"
          @dateClick="onDateClick"
          @eventClick="onEventClick"
          @eventDrop="onEventDrop"
          defaultView="dayGridMonth"/>
          <modal v-model="modalVisible" width="250px" :title="$t('app.calendar.dateSelectModalTitle')" class-name='date-select-modal' @on-ok="gotoDate">
            <el-date-picker style="width: 200px;" v-model="selectedGotoDate" type="date"></el-date-picker>
          </modal>
        </template>
      </context-menu-container>
    </div>
</template>
// 基于 @CONTROL/日历部件/CONTROL-BASE.vue.ftl 生成


<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model,Inject } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util,ViewTool } from '@/utils';
import NavDataService from '@/service/app/navdata-service';
import AppCenterService from "@service/app/app-center-service";
import IBIZBOOKEntityService from '@/service/ibizbook/ibizbook-service';
import BookCalendarMajorStateService from './book-calendar-major-state-calendar-service';
import IBIZBOOKUIService from '@/uiservice/ibizbook/ibizbook-ui-service';
import FullCalendar from '@fullcalendar/vue'
import dayGridPlugin from '@fullcalendar/daygrid'
import timeGridPlugin from '@fullcalendar/timegrid';
import listPlugin from '@fullcalendar/list';
import interactionPlugin from '@fullcalendar/interaction';
import ContextMenu from '@components/context-menu/context-menu';
import UIService from '@/uiservice/ui-service';


@Component({
    components: {
      FullCalendar,

    }
})
export default class BookCalendarMajorStateBase extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof BookCalendarMajorStateBase
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof BookCalendarMajorStateBase
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof BookCalendarMajorStateBase
     */
    @Prop() public context!: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof BookCalendarMajorStateBase
     */
    @Prop() public viewparams!: any;

    /**
     * 视图操作参数(父级)
     *
     * @type {*}
     * @memberof BookCalendarMajorStateBase
     */
    @Prop() public pViewCtx!: any;

    /**
     * 视图操作参数
     *
     * @type {*}
     * @memberof BookCalendarMajorStateBase
     */
    public viewCtx: any = {};

    /**
     * 监听视图操作参数变化
     *
     * @type {*}
     * @memberof BookCalendarMajorStateBase
     */
    @Watch('pViewCtx', { immediate: true })
    public onViewCtxChange(newVal: any, oldVal: any) {
        Object.assign(this.viewCtx, newVal, { xData: this, ctrl: this });
    }

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof BookCalendarMajorStateBase
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof BookCalendarMajorStateBase
     */
    public getControlType(): string {
        return 'CALENDAR'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof BookCalendarMajorStateBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {BookCalendarMajorStateService}
     * @memberof BookCalendarMajorStateBase
     */
    public service: BookCalendarMajorStateService = new BookCalendarMajorStateService({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {IBIZBOOKService}
     * @memberof BookCalendarMajorStateBase
     */
    public appEntityService: IBIZBOOKEntityService = new IBIZBOOKEntityService({ $store: this.$store });

    /**
     * cm 部件 click 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof BookCalendarMajorStateBase
     */
    public cm_click($event: any, $event2?: any) {
        if (Object.is($event.tag, 'deuiaction1')) {
            this.cm_deuiaction1_click(null, 'cm', $event2);
        }
        if (Object.is($event.tag, 'deuiaction2')) {
            this.cm_deuiaction2_click(null, 'cm', $event2);
        }
        if (Object.is($event.tag, 'deuiaction3')) {
            this.cm_deuiaction3_click(null, 'cm', $event2);
        }
    }
    

    /**
     * 逻辑事件
     *
     * @param {*} [params={}]
     * @param {*} [tag]
     * @param {*} [$event]
     * @memberof 
     */
    public cm_deuiaction1_click(params: any = {}, tag?: any, $event?: any) {
        // 参数
        // 取数
        let datas: any[] = [];
        let xData: any = null;
        // _this 指向容器对象
        const _this: any = this;
        let paramJO:any = {};
        let contextJO:any = {};
        xData = this;
        if (_this.getDatas && _this.getDatas instanceof Function) {
            datas = [..._this.getDatas()];
        }
        if(params){
          datas = [params];
        }
        // 界面行为
        const curUIService:IBIZBOOKUIService  = new IBIZBOOKUIService();
        curUIService.IBIZBOOK_Edit(datas,contextJO, paramJO,  $event, xData,this,"IBIZBOOK");
    }

    /**
     * 逻辑事件
     *
     * @param {*} [params={}]
     * @param {*} [tag]
     * @param {*} [$event]
     * @memberof 
     */
    public cm_deuiaction2_click(params: any = {}, tag?: any, $event?: any) {
        // 参数
        // 取数
        let datas: any[] = [];
        let xData: any = null;
        // _this 指向容器对象
        const _this: any = this;
        let paramJO:any = {};
        let contextJO:any = {};
        xData = this;
        if (_this.getDatas && _this.getDatas instanceof Function) {
            datas = [..._this.getDatas()];
        }
        if(params){
          datas = [params];
        }
        // 界面行为
        const curUIService:IBIZBOOKUIService  = new IBIZBOOKUIService();
        curUIService.IBIZBOOK_Delete(datas,contextJO, paramJO,  $event, xData,this,"IBIZBOOK");
    }

    /**
     * 逻辑事件
     *
     * @param {*} [params={}]
     * @param {*} [tag]
     * @param {*} [$event]
     * @memberof 
     */
    public cm_deuiaction3_click(params: any = {}, tag?: any, $event?: any) {
        // 参数
        // 取数
        let datas: any[] = [];
        let xData: any = null;
        // _this 指向容器对象
        const _this: any = this;
        let paramJO:any = {};
        let contextJO:any = {};
        xData = this;
        if (_this.getDatas && _this.getDatas instanceof Function) {
            datas = [..._this.getDatas()];
        }
        if(params){
          datas = [params];
        }
        // 界面行为
        const curUIService:IBIZBOOKUIService  = new IBIZBOOKUIService();
        curUIService.IBIZBOOK_openDocument(datas,contextJO, paramJO,  $event, xData,this,"IBIZBOOK");
    }


    /**
     * 转化数据
     *
     * @param {any} args
     * @memberof  BookCalendarMajorStateBase
     */
    public transformData(args: any) {
        let _this: any = this;
        if(_this.service && _this.service.handleRequestData instanceof Function && _this.service.handleRequestData('transform',_this.context,args)){
            return _this.service.handleRequestData('transform',_this.context,args)['data'];
        }
    }

    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof BookCalendarMajorStateBase
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof BookCalendarMajorStateBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }
    /**
     *  处理部件事件
     *
     * @memberof BookCalendarMajorStateBase
     */
    public async handleCtrlEvents(eventName: string, args: any = {}): Promise<boolean> {
        const actionData = {
            data: this.getData() || {},
            context: Util.deepCopy(this.context),
            viewparams: Util.deepCopy(this.viewparams),
            xData: this
        }
        let result: boolean = true;
        Object.assign(actionData, args);
        if (!result) {
            return false;
        }
        this.$emit(eventName, actionData);
        return true;
    }




    /**
     * 是否默认选中第一条数据
     *
     * @type {boolean}
     * @memberof BookCalendarMajorStateBase
     */
    @Prop({ default: false }) public isSelectFirstDefault!: boolean;

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof BookCalendarMajorStateBase
     */
    @Prop({ default: true }) public showBusyIndicator?: boolean;

    /**
     * 部件行为--load
     *
     * @type {string}
     * @memberof BookCalendarMajorStateBase
     */
    @Prop() public loadAction!: string;

    /**
     * 打开新建数据视图
     *
     * @type {any}
     * @memberof BookCalendarMajorStateBase
     */
    @Prop() public newdata: any;
    /**
     * 打开编辑数据视图
     *
     * @type {any}
     * @memberof BookCalendarMajorStateBase
     */
    @Prop() public opendata: any;

    /**
     * 日历部件样式名
     *
     * @public
     * @type {any[]}
     * @memberof BookCalendarMajorStateBase
     */
    public calendarClass: string = "calendar";

    /**
     * this引用
     *
     * @type {any}
     * @memberof BookCalendarMajorStateBase
     */
    public thisRef: any = this;

    /**
     * 选中事件element元素
     *
     * @public
     * @type {any[]}
     * @memberof BookCalendarMajorStateBase
     */
    public selectedEventElement:any;

    /**
     * 是否显示事件时也显示时间
     *
     * @public
     * @type {boolean}
     * @memberof BookCalendarMajorStateBase
     */
    public displayEventTime: boolean = true;

    /**
     * 引用插件集合
     *
     * @public
     * @type {any[]}
     * @memberof BookCalendarMajorStateBase
     */
    public calendarPlugins: any[] = [
        dayGridPlugin, 
        timeGridPlugin, 
        listPlugin, 
        interactionPlugin
    ];

    /**
     * 设置头部显示
     *
     * @public
     * @type {}
     * @memberof BookCalendarMajorStateBase
     */
    public header: any = {
        left: 'prev,next today gotoDate',
        center: 'title',
        right: 'dayGridMonth,timeGridWeek,timeGridDay,listWeek'
    };

    /**
     * 按钮文本集合
     *
     * @public
     * @type {}
     * @memberof BookCalendarMajorStateBase
     */
    public buttonText: any = {
        today: '今天',
        month: '月',
        week: '周',
        day: '天',
        list: '列'
    };

    /**
     * 自定义按钮集合
     *
     * @public
     * @type {}
     * @memberof BookCalendarMajorStateBase
     */
    public customButtons: any = {
        gotoDate: {
          text: "跳转",
          click: this.openDateSelect
        }
    };

    /**
     * 模态显示控制变量
     *
     * @public
     * @type boolean
     * @memberof BookCalendarMajorStateBase
     */
    public modalVisible: boolean = false;

    /**
     * 跳转日期
     *
     * @public
     * @type Date
     * @memberof BookCalendarMajorStateBase
     */
    public selectedGotoDate: Date = new Date();

    /**
     * 打开时间选择模态
     *
     * @public
     * @memberof BookCalendarMajorStateBase
     */
    public openDateSelect(){
        this.modalVisible = true;
    }

    /**
     * 跳转到指定时间
     *
     * @public
     * @memberof BookCalendarMajorStateBase
     */
    public gotoDate(){
        let appCalendar: any = this.$refs.calendar;
        let api = appCalendar.getApi();
        api.gotoDate(this.selectedGotoDate);
    }

    /**
     * 有效日期范围
     *
     * @public
     * @type {}
     * @memberof BookCalendarMajorStateBase
     */
    public validRange: any = {
        start:"0000-01-01",
        end:"9999-12-31"
    };

    /**
     * 默认加载日期
     *
     * @public
     * @type {}
     * @memberof BookCalendarMajorStateBase
     */
    public defaultDate: any = this.$util.dateFormat(new Date());

    /**
     * 设置按钮文本
     *
     * @public
     * @memberof BookCalendarMajorStateBase
     */
    public setButtonText(){
        this.buttonText.today = this.$t('app.calendar.today'),
        this.buttonText.month = this.$t('app.calendar.month'),
        this.buttonText.week = this.$t('app.calendar.week'),
        this.buttonText.day = this.$t('app.calendar.day'),
        this.buttonText.list = this.$t('app.calendar.list')
        this.customButtons.gotoDate.text = this.$t('app.calendar.gotoDate')
    }

    /**
     * 监听语言变化
     *
     * @public
     * @memberof BookCalendarMajorStateBase
     */
    @Watch('$i18n.locale')
    public onLocaleChange(newval: any, val: any) {
        this.setButtonText();
    }

    /**
     * 日程事件集合
     *
     * @public
     * @type {any[]}
     * @memberof BookCalendarMajorStateBase
     */
    public events: any[] = [];

    /**
     * 日历项上下文菜单集合
     *
     * @type {string[]}
     * @memberof BookCalendarMajorStateBase
     */
     public actionModel: any = {
        item_deuiaction1: {name:'deuiaction1',nodeOwner:'item',type: 'DEUIACTION', tag: 'Edit', actiontarget: 'SINGLEKEY', noprivdisplaymode:1, dataaccaction:'EDIT', visabled: true, disabled: false},
        item_deuiaction2: {name:'deuiaction2',nodeOwner:'item',type: 'DEUIACTION', tag: 'Delete', actiontarget: 'SINGLEKEY', noprivdisplaymode:1, dataaccaction:'DELETE', visabled: true, disabled: false},
        item_deuiaction3: {name:'deuiaction3',nodeOwner:'item',type: 'DEUIACTION', tag: 'openDocument', actiontarget: 'SINGLEKEY', noprivdisplaymode:1, dataaccaction:'OPEN_DOCUMENT', visabled: true, disabled: false},
    }

    /**
     * 备份日历项上下文菜单
     *
     * @type {string[]}
     * @memberof BookCalendarMajorStateBase
     */
     public copyActionModel: any;

    /**
     * 日历样式类型
     *
     * @public
     * @type {string}
     * @memberof BookCalendarMajorStateBase
     */
    public calendarType: string = "MONTH";

    /**
     * 图例显示控制
     *
     * @public
     * @type {any}
     * @memberof BookCalendarMajorStateBase
     */
    public isShowlegend: any = {
        item:true,
    };

    /**
     * 图例点击事件
     *
     * @public
     * @memberof BookCalendarMajorStateBase
     */
    legendTrigger(itemType:string){
        this.isShowlegend[itemType] = !this.isShowlegend[itemType];
        this.refresh();
    }

    /**
     * 查询参数缓存
     *
     * @public
     * @type {any}
     * @memberof BookCalendarMajorStateBase
     */
    public searchArgCache: any = {};


    /**
     * 搜索获取日程事件
     *
     * @param {*} $event 日期信息
     * @memberof BookCalendarMajorStateBase
     */
    public searchEvents(fetchInfo?:any, successCallback?:any, failureCallback?:any ) {
        // 处理请求参数
        let start = (fetchInfo && fetchInfo.start) ? this.$util.dateFormat(fetchInfo.start) : null;
        let end = (fetchInfo && fetchInfo.end) ? this.$util.dateFormat(fetchInfo.end) : null;
        let arg = { start: start, end: end };
        if(fetchInfo && fetchInfo.query){
            Object.assign(arg,{query : fetchInfo.query});
        }
        const parentdata: any = {};
        this.$emit('beforeload', parentdata);
        Object.assign(arg, parentdata);
        let tempViewParams: any = parentdata.viewparams ? parentdata.viewparams : {};
        Object.assign(tempViewParams, JSON.parse(JSON.stringify(this.viewparams)));
        Object.assign(arg, { viewparams: tempViewParams });
        // 处理events数据
        let _this = this;
        let handleEvents = () => {
            if(_this.isSelectFirstDefault){
                // 模拟$event数据
                let tempEvent = JSON.parse(JSON.stringify(_this.events.length > 0?_this.events[0]:{}));
                _this.onEventClick(tempEvent,true);
                if(_this.events.length > 0){
                    _this.events[0].className = "select-first-event";
                }
                _this.calendarClass = "calendar select-first-calendar";
            }
            let filterEvents = this.events.filter((event:any)=>{
                return _this.isShowlegend[event.itemType];
            });

            if(successCallback){
                successCallback(filterEvents);
            }
            // 刷新日历的大小（仅fullcalendar组件使用）
            if(!Object.is(_this.calendarType,"TIMELINE")){
                let appCalendar: any = _this.$refs.calendar;
                let api = appCalendar.getApi();
                api.updateSize();
            }
        }
        if (JSON.stringify(arg) === JSON.stringify(this.searchArgCache)) {
            handleEvents();
            return;
        } else {
            this.searchArgCache = arg;
        }
        this.handleCtrlEvents('onbeforeload', { viewparams: arg }).then((beforeLoadRes: boolean) => {
            if (!beforeLoadRes) {
                return;
            }
            const post: Promise<any> = this.service.search(this.loadAction, JSON.parse(JSON.stringify(this.context)), arg, this.showBusyIndicator);
            post.then((response: any) => {
                if (!response || response.status !== 200) {
                    this.handleCtrlEvents('onloaderror', { viewparams: arg }).then((loadErrorRes: boolean) => {
                        if (!loadErrorRes) {
                            return;
                        }
                        if (response.data && response.data.message) {
                            this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: response.data.message });
                        }
                    });
                    return;
                }
                this.handleCtrlEvents('onloadsuccess', { data: response.data }).then((loadSuccessRes: boolean) => {
                    if (!loadSuccessRes) {
                        return;
                    }
                    // 默认选中第一项
                    this.events = response.data;
                    handleEvents();
                })
            }, (response: any) => {
                this.handleCtrlEvents('onloaderror', { viewparams: arg }).then((loadErrorRes: boolean) => {
                    if (!loadErrorRes) {
                        return;
                    }
                    if (response && response.status === 401) {
                        return;
                    }
                    this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: response.data && response.data.message ? response.data.message : "" });
                });
            });
        })
    }

    /**
     * 日期点击事件
     *
     * @param {*} $event 日期信息
     * @memberof BookCalendarMajorStateBase
     */
    public onDateClick($event: any) {
        let date = $event.date;
        let datestr = $event.dateStr;
    }

    /**
     * 获取编辑视图信息
     *
     * @param {*} $event 事件信息
     * @memberof BookCalendarMajorStateBase
     */
    public getEditView(deName: string) {
        let view: any = {};
        switch(deName){
            case "ibizbook": 
                view = {
                    viewname: 'ibizbookusr3-edit-view', 
                    height: 0, 
                    width: 0,
                    title: this.$t('PAGE.TITLE.IBIZBOOK.USR3EDITVIEW'),
                    placement: '',
                    deResParameters: [],
                    parameters: [{ pathName: 'ibizbooks', parameterName: 'ibizbook' }, { pathName: 'usr3editview', parameterName: 'usr3editview' } ],
                };
                break;
        }
        return view;
    }

    /**
     * 日程点击事件
     *
     * @param {*} $event calendar事件对象或event数据
     * @param {*} isOriginData true：$event是原始event数据，false：是组件
     * @param {*} $event timeline事件对象
     * @memberof BookCalendarMajorStateBase
     */
    public onEventClick($event: any, isOriginData:boolean = false, $event2?: any) {
        this.handleCtrlEvents('onselectionchange', { data: $event }).then((res: boolean) => {
            if (!res) {
                return;
            }
            // 处理event数据
            let event: any = {};
            if(isOriginData){
                event = JSON.parse(JSON.stringify($event));
            }else{
                event = Object.assign({title: $event.event.title, start: $event.event.start, end: $event.event.end}, $event.event.extendedProps);
            }
            // 点击选中样式
            let JSelement:any = null;
            if(!isOriginData && $event.el){
                JSelement = $event.el;
            }else if(isOriginData && $event2 && $event2.currentTarget){
                JSelement = $event2.currentTarget;
            }
            if(JSelement){
                this.calendarClass = "calendar";
                if(this.selectedEventElement){
                    this.selectedEventElement.classList.remove("selected-event");
                }
                this.selectedEventElement = JSelement;
                this.selectedEventElement.classList.add("selected-event");
            }
            // 处理上下文数据
            let _this = this;
            let view: any = {};
            let _context: any = Object.assign({},this.context);
            let _viewparams:any = Object.assign({start:event.start,end:event.end},this.viewparams);
            switch(event.itemType) {
                case "item":
                    _context.ibizbook = event.ibizbook;
                    view = this.getEditView("ibizbook");
                    break;
            }
            this.selections = [event];
            // 导航栏中不需要打开视图，只要抛出选中数据
            if(this.isSelectFirstDefault){
                this.$emit("selectionchange",this.selections);
                return;
            }
            // 根据打开模式打开视图
            if(!view.viewname){
                return;
            } else if (Object.is(view.placement, 'INDEXVIEWTAB') || Object.is(view.placement, '')) {
                const routePath = this.$viewTool.buildUpRoutePath(this.$route, this.context, view.deResParameters, view.parameters, [JSON.parse(JSON.stringify(_context))] , _viewparams);
                this.$router.push(routePath);
            } else {
                let container: Subject<any> = new Subject();
                if (Object.is(view.placement, 'POPOVER')) {
                    container = this.$apppopover.openPop(isOriginData ? $event2 : $event.jsEvent, view,JSON.parse(JSON.stringify(_context)), _viewparams);
                } else if (Object.is(view.placement, 'POPUPMODAL')) {
                    container = this.$appmodal.openModal(view,  JSON.parse(JSON.stringify(_context)), _viewparams);
                } else if (view.placement.startsWith('DRAWER')) {
                    container = this.$appdrawer.openDrawer(view,  JSON.parse(JSON.stringify(_context)),  _viewparams);
                }
                container.subscribe((result: any) => {
                    if (!result || !Object.is(result.ret, 'OK')) {
                        return;
                    }
                    // 刷新日历
                    _this.refresh();
                });
            }
        })

    }

    /**
     * 日历刷新
     *
     * @memberof BookCalendarMajorStateBase
     */
    public refresh(args?:any) {
        if(Object.is(this.calendarType,"TIMELINE")){
            this.searchEvents();
        } else {
            let calendarApi = (this.$refs.calendar as any).getApi();
            calendarApi.refetchEvents();
        }
    }

    /**
     * 日程拖动事件
     *
     * @param {*} $event 事件信息
     * @memberof BookCalendarMajorStateBase
     */
    public onEventDrop($event: any) {
        if(this.isSelectFirstDefault){
          return;
        }
        let arg: any = {};
        let _context: any = Object.assign({},this.context);
        arg.start = this.$util.dateFormat($event.event.start);
        arg.end = this.$util.dateFormat($event.event.end);
        let itemType = $event.event._def.extendedProps.itemType;
        switch(itemType) {
            case "item":
                arg.ibizbook = $event.event._def.extendedProps.ibizbook;
                _context.ibizbook = $event.event._def.extendedProps.ibizbook;
                break;
        }
        Object.assign(arg, { viewparams: this.viewparams} );
        this.handleCtrlEvents('onbeforedrop', { viewparams: arg }).then((beforeDropRes: boolean) => {
            if (!beforeDropRes) {
                return;
            }
            const post: Promise<any> = this.service.update(itemType, JSON.parse(JSON.stringify(_context)), arg, this.showBusyIndicator);
            post.then((response: any) => {
                if (!response || response.status !== 200) {
                    this.handleCtrlEvents('ondroperror', { data: response && response.data ? response.data : [] }).then((res: boolean) => {
                        if (!res) {
                            return;
                        }
                        if (response.data && response.data.message) {
                            this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: response.data.message });
                        }
                        return;
                    })
                }
                this.handleCtrlEvents('ondropsuccess', { data: response.data }).then((res: boolean) => {
                    if (!res) {
                        return;
                    }
                })
            }, (response: any) => {
                this.handleCtrlEvents('ondroperror', { data: response && response.data ? response.data : [] }).then((res: boolean) => {
                    if (!res) {
                        return;
                    }
                    if (response && response.status === 401) {
                        return;
                    }
                    this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: response.data && response.data.message ? response.data.message : "" });
                })
            })
        });
    }

    /**
     * 选中的数据
     *
     * @returns {any[]}
     * @memberof BookCalendarMajorStateBase
     */
    public selections: any[] = [];

    /**
     * 应用状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof BookCalendarMajorStateBase
     */
    public appStateEvent: Subscription | undefined;

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof BookCalendarMajorStateBase
     */
    public getDatas(): any[] {
        return this.selections;
    }

    /**
     * 获取单项数据
     *
     * @returns {*}
     * @memberof BookCalendarMajorStateBase
     */
    public getData(): any {
        return null;
    }
             
    /**
     * vue 生命周期
     *
     * @returns
     * @memberof BookCalendarMajorStateBase
     */
    public created() {
        this.setButtonText();
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof BookCalendarMajorStateBase
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
            });
        }
        if(AppCenterService && AppCenterService.getMessageCenter()){
            this.appStateEvent = AppCenterService.getMessageCenter().subscribe(({ name, action, data }) =>{
                if(!Object.is(name,"IBIZBOOK")){
                    return;
                }
                if(Object.is(action,'appRefresh')){
                    this.refresh();
                }
            })
        }
    }


    /**
     * vue 生命周期
     *
     * @memberof BookCalendarMajorStateBase
     */
    public mounted(){
        this.afterMounted();
    }

    /**
     * 执行mounted后的逻辑
     *
     * @memberof BookCalendarMajorStateBase
     */
    public afterMounted(){
        let appCalendar: any = this.$refs.calendar;
        if(appCalendar){
            let api = appCalendar.getApi();
            api.updateSize()
        }
    }

    /**
     * vue 生命周期
     *
     * @memberof BookCalendarMajorStateBase
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof BookCalendarMajorStateBase
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        if(this.appStateEvent){
            this.appStateEvent.unsubscribe();
        }
    }



    /**
     * 计算节点右键权限
     *
     * @param {*} data 日历项数据
     * @param {*} appEntityName 应用实体名称  
     * @returns
     * @memberof BookCalendarMajorStateBase
     */
    public async computeNodeState(data:any,appEntityName:string) {
        let service:any = await this.appEntityService.getService(appEntityName);
        if(this.copyActionModel && Object.keys(this.copyActionModel).length > 0) {
            if(service['Get'] && service['Get'] instanceof Function){
                let tempContext:any = Util.deepCopy(this.context);
                tempContext[appEntityName] = data[appEntityName];
                let targetData = await service.Get(tempContext,{}, false);
                let uiservice:any = await new UIService().getService(appEntityName);
                let result: any[] = ViewTool.calcActionItemAuthState(targetData.data,this.copyActionModel,uiservice);
                return this.copyActionModel;
            }else{
                console.warn("获取数据异常");
                return this.copyActionModel;
            }
        }
    }

    /**
     * 事件绘制回调
     *
     * @param {*} info 信息
     * @memberof BookCalendarMajorStateBase
     */
    public eventRender(info?:any,) {
        let data = Object.assign({title: info.event.title, start: info.event.start, end: info.event.end}, info.event.extendedProps);
        info.el.addEventListener('contextmenu', (event: MouseEvent) => {
            this.copyActionModel = {};
            Object.values(this.actionModel).forEach((item:any) =>{
                if(Object.is(item.nodeOwner,data.itemType)){
                    this.copyActionModel[item.name] = item;
                }
            })
            if(Object.keys(this.copyActionModel).length === 0){
                return;
            }
            let dataMapping:any ={'item':'ibizbook'};
            this.computeNodeState(data,dataMapping[data.itemType]).then((result:any) => {
                let flag:boolean = false;
                if(Object.values(result).length>0){
                    flag =Object.values(result).some((item:any) =>{
                        return item.visabled === true;
                    })
                }
                if(flag){
                    let props = { data: data, renderContent: this.renderContextMenu };
                    let component = ContextMenu;
                    const vm:any = new Vue({
                        render(h) {
                            return h(component, { props });
                        }
                    }).$mount();
                    document.body.appendChild(vm.$el);
                    const comp: any = vm.$children[0];
                    comp.showContextMenu(event.clientX, event.clientY);
                }
            });
        });
    }

    /**
     * 绘制右键菜单
     *
     * @param {*} event
     * @returns
     * @memberof BookCalendarMajorStateBase
     */
    public renderContextMenu(event: any) {
        let content;
        if (event && event.itemType) {
            const data: any = JSON.parse(JSON.stringify(event));
            this.selections = [event];
            switch(event.itemType){
            case "item":
                content = this.renderContextMenuItem();
                break;
            }
        }
        return content;
    }

    /**
     * 绘制item类型右键菜单
     *
     * @returns
     * @memberof BookCalendarMajorStateBase
     */
    public renderContextMenuItem() {
        return (
                      <dropdown class="tree-right-menu" trigger="custom" visible={true} on-on-click={($event: any) => this.cm_click({tag: $event})}>
                <dropdown-menu slot="list">
                            <dropdown-item name='deuiaction1' v-show={this.copyActionModel['deuiaction1'].visabled} disabled={this.copyActionModel['deuiaction1'].disabled}>
                        <i class='fa fa-edit'></i>
                        编辑
                    </dropdown-item>
                            <dropdown-item name='deuiaction2' v-show={this.copyActionModel['deuiaction2'].visabled} disabled={this.copyActionModel['deuiaction2'].disabled}>
                        <i class='fa fa-remove'></i>
                        删除
                    </dropdown-item>
                            <dropdown-item name='deuiaction3' v-show={this.copyActionModel['deuiaction3'].visabled} disabled={this.copyActionModel['deuiaction3'].disabled}>
                        
                        打开文档
                    </dropdown-item>
                </dropdown-menu>
            </dropdown>
        );
    }

}
</script>

<style lang='scss'>
@import './book-calendar-major-state-calendar.scss';
</style>